/**
 * %wsgw_sample_start%
 * Licensed Materials - Property of IBM
 *
 * (c) Copyright IBM Corp. 2001, 2002 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 * %wsgw_sample_end%
 */

// Find orphaned responses

package services.lftfileservice;

import com.ibm.httpr.persistapi.Cursor;
import com.ibm.httpr.persistapi.HTTPRException;
import com.ibm.httpr.persistapi.Msg;
import com.ibm.httpr.persistapi.StateManager;
import com.ibm.httpr.pix.PixMgrFactory;
import com.ibm.httpr.pix.PixStateMgr;

public class orphan
{

public static void main(
   String            args[])
  {
   long              when;             /* Creation time of response message  */

   PixMgrFactory factory = new PixMgrFactory();
   long now = System.currentTimeMillis(); /* Compare to time in messages     */
   boolean killed = false;             /* Messages have (not yet) been removed*/
   try
     {
      factory.init("");
      StateManager mgr = factory.getStateManager(); /* Begin transaction     */
      Cursor c = mgr.getLocalMessages("HTTPR.DEMO.RESPONSE");
      for (;;)
        {
         Msg m = c.getNextMessageNow();/* Get what we can get immediately    */
         if (m==null)                  /* No more to get                     */
            break;
         String created = m.getMessageHeader(PixStateMgr.creationTimeField);
         if (created==null)
           {
            System.out.println("\nFound an odd response message.\n"+
                  "We'll invent a timestamp of 0 for it.");
            when=0;
           }
         else
            when=Long.parseLong(created);
         if (now-when>10000)           /* It's been sitting here a while     */
           {
            System.out.println("\nFound orphaned response message: "+m);
            System.out.println("This has been lying around for "+
                  ((now-when)/1000.0)+" seconds.");
            if (args.length>0 && args[0].equals("cancel"))
              {
               System.out.println("We'll remove it.");
               killed=true;            /* Commit our changes                 */
               mgr.removeMessage(m);   /* Get rid of this orphan             */
              }
           }
        }
      mgr.endUpdate(killed);           /* Roll back unless we killed         */
     }
   catch (HTTPRException e)
     {
      e.printStackTrace();
     }
  }
}
