@title HTTPR File Transfer Status - IBM WebServices Gateway
@cls
@rem Usage: status.bat <wsgw_dir> <stateFile_dir> <optional_param>, where
@rem  <wsgw_dir> is the WebServices Gateway Directory (no trailing slash),
@rem  <stateFile_dir> is the directory containing the httpr state file, stateFile (no trailing slash),
@rem  <optional_param> is cancel, or no parameter is typed.

@echo.
@echo This utility lists the status of large file transfers over httpr.
@echo It can be run for the sending or the receiving end, as determined by the stateFile_dir parameter.
@echo.

@if .%1==. goto invalidparams
@if .%2==. goto invalidparams

@rem Check parameter 1 is a valid directory.
@if EXIST %1 goto goodparam1
@echo The directory %1 specified for the WebServices Gateway does not exist.
@echo.
@goto invalidparams

@rem Check parameter 2 is a valid directory.
:goodparam1
@if EXIST %2 goto goodparams
@echo The directory %2 specified for the HTTPR stateFile does not exist.
@echo.
@goto invalidparams

:goodparams
@java -DSTATE_FILE=%2\stateFile -Djava.protocol.handler.pkgs=com.ibm.axis.transport -Dlft-directory=%1\serverTemp -Dlft-piFactory=com.ibm.httpr.file.FileStateManagerFactory -classpath %1\lib\wsgw-samples.jar;%1\lib\httpr.jar services.lftfileservice.status %3
@goto :eof

:invalidparams
@echo Usage: status.bat wsgw_dir stateFile_dir optional_param, where
@echo  wsgw_dir is the WebServices Gateway Directory (no trailing slash),
@echo  stateFile_dir is the directory containing the httpr state file, stateFile (no trailing slash),
@echo  optional_param is cancel, or no parameter is typed.
@echo Examples:
@echo (client end, no cancel option):
@echo status.bat D:\data\W110.L020820\wsgw_was4 D:\data\W110.L020820\wsgw_was4\samples\services\lftfileservice
@echo (AppServer end, cancel option):
@echo status.bat D:\data\W110.L020820\wsgw_was4 D:\ProgramFiles\WebSphere\AppServer\bin cancel
@echo.
