/**
 * %wsgw_sample_start%
 * Licensed Materials - Property of IBM
 *
 * (c) Copyright IBM Corp. 2001, 2002 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 * %wsgw_sample_end%
 */

// Check on the status of large file transfers

package services.lftfileservice;

import com.ibm.httpr.persistapi.HTTPRException;
import com.ibm.httpr.pix.FileRef;
import com.ibm.httpr.pix.PixMgrFactory;
import com.ibm.httpr.pix.PixStateMgr;
import com.ibm.httpr.pix.SetOfRefs;

import java.io.BufferedReader;
import java.io.InputStreamReader;

public class status
{

public static void main(
   String            args[])
  {
   String            dest;             /* Specific destination to query about*/
   String            answer;           /* Answer to cancel query             */

   if (args.length<1)
      dest=null;
   else
      dest=args[0];

   BufferedReader    rdr = new BufferedReader( /* To read lines              */
         new InputStreamReader(System.in));
   PixMgrFactory factory = new PixMgrFactory();
   try
     {
      factory.init("");
      SetOfRefs s = PixStateMgr.getStatus();
      SetOfRefs.FileIterator i = s.iterator();
      while (i.hasNext())
        {
         FileRef r = i.next();
         String fromFile = r.getFromFile();
         if (fromFile==null)           /* Incoming file                      */
           {
            System.out.println(r.getToFile()+"("+r.getMsgId()+") from "+
                  r.getAgent()+": received "+r.getOffset()+" of "+r.length()+
                  " bytes");
           }
         else                          /* Outgoing file                      */
           {
            System.out.println(fromFile+"("+r.getMsgId()+") to "+r.getAgent()+
                  ": sent "+r.getOffset()+" of "+r.length()+" bytes");
           }
         long runningMillis = System.currentTimeMillis()-r.getStartTime();
         System.out.println("   running "+runningMillis/1000.0+" seconds");
         if (r.getOffset()>0)          /* Have something to estimate from    */
           {
            float fracDone = r.getOffset()/(float)r.length();
            int todoMillis = (int)(runningMillis*(1.0/fracDone-1.0));
            System.out.println("   project completion in "+todoMillis/1000.0+
                  " seconds");
           }
         if (args.length>0 && args[0].equals("cancel"))
           {
            System.out.println("   cancel it (y/n)?");
            try
              {
               answer=rdr.readLine();
               if ("y".equals(answer))
                 {
                  if (fromFile!=null)  /* Outgoing file                      */
                     PixStateMgr.cancelOutgoing(r.getMsgId(),r.getAgent());
                  else                 /* Incoming file                      */
                     PixStateMgr.cancelIncoming(r.getMsgId());
                 }
              }
            catch (Exception e)
              {
               e.printStackTrace();
              }
           }
        }
     }
   catch (HTTPRException e)
     {
      e.printStackTrace();
     }
  }
}
